// Autogenerated from Pigeon (v11.0.0), do not edit directly.
// See also: https://pub.dev/packages/pigeon

import Foundation
#if os(iOS)
import Flutter
#elseif os(macOS)
import FlutterMacOS
#else
#error("Unsupported platform.")
#endif

private func isNullish(_ value: Any?) -> Bool {
  return value is NSNull || value == nil
}

private func wrapResult(_ result: Any?) -> [Any?] {
  return [result]
}

private func wrapError(_ error: Any) -> [Any?] {
  if let flutterError = error as? FlutterError {
    return [
      flutterError.code,
      flutterError.message,
      flutterError.details
    ]
  }
  return [
    "\(error)",
    "\(type(of: error))",
    "Stacktrace: \(Thread.callStackSymbols)"
  ]
}

private func nilOrValue<T>(_ value: Any?) -> T? {
  if value is NSNull { return nil }
  return value as! T?
}

/// Generated class from Pigeon that represents data sent in messages.
struct ConversationClientData {
  var myIdentity: String? = nil
  var connectionState: String? = nil
  var isReachabilityEnabled: Bool? = nil

  static func fromList(_ list: [Any?]) -> ConversationClientData? {
    let myIdentity: String? = nilOrValue(list[0])
    let connectionState: String? = nilOrValue(list[1])
    let isReachabilityEnabled: Bool? = nilOrValue(list[2])

    return ConversationClientData(
      myIdentity: myIdentity,
      connectionState: connectionState,
      isReachabilityEnabled: isReachabilityEnabled
    )
  }
  func toList() -> [Any?] {
    return [
      myIdentity,
      connectionState,
      isReachabilityEnabled,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct PropertiesData {
  var region: String? = nil

  static func fromList(_ list: [Any?]) -> PropertiesData? {
    let region: String? = nilOrValue(list[0])

    return PropertiesData(
      region: region
    )
  }
  func toList() -> [Any?] {
    return [
      region,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct ConversationData {
  var sid: String? = nil
  var friendlyName: String? = nil
  var uniqueName: String? = nil
  var status: String? = nil
  var state: String? = nil
  var synchronizationStatus: String? = nil
  var dateCreated: String? = nil
  var createdBy: String? = nil
  var dateUpdated: String? = nil
  var lastMessageDate: String? = nil
  var lastReadMessageIndex: Int64? = nil
  var lastMessageIndex: Int64? = nil
  var attributes: AttributesData? = nil

  static func fromList(_ list: [Any?]) -> ConversationData? {
    let sid: String? = nilOrValue(list[0])
    let friendlyName: String? = nilOrValue(list[1])
    let uniqueName: String? = nilOrValue(list[2])
    let status: String? = nilOrValue(list[3])
    let state: String? = nilOrValue(list[4])
    let synchronizationStatus: String? = nilOrValue(list[5])
    let dateCreated: String? = nilOrValue(list[6])
    let createdBy: String? = nilOrValue(list[7])
    let dateUpdated: String? = nilOrValue(list[8])
    let lastMessageDate: String? = nilOrValue(list[9])
    let lastReadMessageIndex: Int64? = isNullish(list[10]) ? nil : (list[10] is Int64? ? list[10] as! Int64? : Int64(list[10] as! Int32))
    let lastMessageIndex: Int64? = isNullish(list[11]) ? nil : (list[11] is Int64? ? list[11] as! Int64? : Int64(list[11] as! Int32))
    var attributes: AttributesData? = nil
    if let attributesList: [Any?] = nilOrValue(list[12]) {
      attributes = AttributesData.fromList(attributesList)
    }

    return ConversationData(
      sid: sid,
      friendlyName: friendlyName,
      uniqueName: uniqueName,
      status: status,
      state: state,
      synchronizationStatus: synchronizationStatus,
      dateCreated: dateCreated,
      createdBy: createdBy,
      dateUpdated: dateUpdated,
      lastMessageDate: lastMessageDate,
      lastReadMessageIndex: lastReadMessageIndex,
      lastMessageIndex: lastMessageIndex,
      attributes: attributes
    )
  }
  func toList() -> [Any?] {
    return [
      sid,
      friendlyName,
      uniqueName,
      status,
      state,
      synchronizationStatus,
      dateCreated,
      createdBy,
      dateUpdated,
      lastMessageDate,
      lastReadMessageIndex,
      lastMessageIndex,
      attributes?.toList(),
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct AttributesData {
  var type: String? = nil
  var data: String? = nil

  static func fromList(_ list: [Any?]) -> AttributesData? {
    let type: String? = nilOrValue(list[0])
    let data: String? = nilOrValue(list[1])

    return AttributesData(
      type: type,
      data: data
    )
  }
  func toList() -> [Any?] {
    return [
      type,
      data,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct TokenData {
  var token: String? = nil

  static func fromList(_ list: [Any?]) -> TokenData? {
    let token: String? = nilOrValue(list[0])

    return TokenData(
      token: token
    )
  }
  func toList() -> [Any?] {
    return [
      token,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct MediaData {
  var sid: String? = nil
  var filename: String? = nil
  var contentType: String? = nil
  var size: Int64? = nil
  var category: String? = nil

  static func fromList(_ list: [Any?]) -> MediaData? {
    let sid: String? = nilOrValue(list[0])
    let filename: String? = nilOrValue(list[1])
    let contentType: String? = nilOrValue(list[2])
    let size: Int64? = isNullish(list[3]) ? nil : (list[3] is Int64? ? list[3] as! Int64? : Int64(list[3] as! Int32))
    let category: String? = nilOrValue(list[4])

    return MediaData(
      sid: sid,
      filename: filename,
      contentType: contentType,
      size: size,
      category: category
    )
  }
  func toList() -> [Any?] {
    return [
      sid,
      filename,
      contentType,
      size,
      category,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct MessageData {
  var sid: String? = nil
  var index: Int64? = nil
  var author: String? = nil
  var subject: String? = nil
  var body: String? = nil
  var attachedMedia: [MediaData?]? = nil
  var conversationSid: String? = nil
  var participantSid: String? = nil
  var dateCreated: String? = nil
  var dateUpdated: String? = nil
  var lastUpdatedBy: String? = nil
  var attributes: AttributesData? = nil

  static func fromList(_ list: [Any?]) -> MessageData? {
    let sid: String? = nilOrValue(list[0])
    let index: Int64? = isNullish(list[1]) ? nil : (list[1] is Int64? ? list[1] as! Int64? : Int64(list[1] as! Int32))
    let author: String? = nilOrValue(list[2])
    let subject: String? = nilOrValue(list[3])
    let body: String? = nilOrValue(list[4])
    let attachedMedia: [MediaData?]? = nilOrValue(list[5])
    let conversationSid: String? = nilOrValue(list[6])
    let participantSid: String? = nilOrValue(list[7])
    let dateCreated: String? = nilOrValue(list[8])
    let dateUpdated: String? = nilOrValue(list[9])
    let lastUpdatedBy: String? = nilOrValue(list[10])
    var attributes: AttributesData? = nil
    if let attributesList: [Any?] = nilOrValue(list[11]) {
      attributes = AttributesData.fromList(attributesList)
    }

    return MessageData(
      sid: sid,
      index: index,
      author: author,
      subject: subject,
      body: body,
      attachedMedia: attachedMedia,
      conversationSid: conversationSid,
      participantSid: participantSid,
      dateCreated: dateCreated,
      dateUpdated: dateUpdated,
      lastUpdatedBy: lastUpdatedBy,
      attributes: attributes
    )
  }
  func toList() -> [Any?] {
    return [
      sid,
      index,
      author,
      subject,
      body,
      attachedMedia,
      conversationSid,
      participantSid,
      dateCreated,
      dateUpdated,
      lastUpdatedBy,
      attributes?.toList(),
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct MessageOptionsData {
  var body: String? = nil
  var attributes: AttributesData? = nil
  var mimeType: String? = nil
  var filename: String? = nil
  var inputPath: String? = nil
  var mediaProgressListenerId: Int64? = nil

  static func fromList(_ list: [Any?]) -> MessageOptionsData? {
    let body: String? = nilOrValue(list[0])
    var attributes: AttributesData? = nil
    if let attributesList: [Any?] = nilOrValue(list[1]) {
      attributes = AttributesData.fromList(attributesList)
    }
    let mimeType: String? = nilOrValue(list[2])
    let filename: String? = nilOrValue(list[3])
    let inputPath: String? = nilOrValue(list[4])
    let mediaProgressListenerId: Int64? = isNullish(list[5]) ? nil : (list[5] is Int64? ? list[5] as! Int64? : Int64(list[5] as! Int32))

    return MessageOptionsData(
      body: body,
      attributes: attributes,
      mimeType: mimeType,
      filename: filename,
      inputPath: inputPath,
      mediaProgressListenerId: mediaProgressListenerId
    )
  }
  func toList() -> [Any?] {
    return [
      body,
      attributes?.toList(),
      mimeType,
      filename,
      inputPath,
      mediaProgressListenerId,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct ParticipantData {
  var sid: String? = nil
  var conversationSid: String? = nil
  var channelType: String? = nil
  var attributes: AttributesData? = nil
  var dateCreated: String? = nil
  var dateUpdated: String? = nil
  var identity: String? = nil
  var lastReadMessageIndex: Int64? = nil
  var lastReadTimestamp: String? = nil

  static func fromList(_ list: [Any?]) -> ParticipantData? {
    let sid: String? = nilOrValue(list[0])
    let conversationSid: String? = nilOrValue(list[1])
    let channelType: String? = nilOrValue(list[2])
    var attributes: AttributesData? = nil
    if let attributesList: [Any?] = nilOrValue(list[3]) {
      attributes = AttributesData.fromList(attributesList)
    }
    let dateCreated: String? = nilOrValue(list[4])
    let dateUpdated: String? = nilOrValue(list[5])
    let identity: String? = nilOrValue(list[6])
    let lastReadMessageIndex: Int64? = isNullish(list[7]) ? nil : (list[7] is Int64? ? list[7] as! Int64? : Int64(list[7] as! Int32))
    let lastReadTimestamp: String? = nilOrValue(list[8])

    return ParticipantData(
      sid: sid,
      conversationSid: conversationSid,
      channelType: channelType,
      attributes: attributes,
      dateCreated: dateCreated,
      dateUpdated: dateUpdated,
      identity: identity,
      lastReadMessageIndex: lastReadMessageIndex,
      lastReadTimestamp: lastReadTimestamp
    )
  }
  func toList() -> [Any?] {
    return [
      sid,
      conversationSid,
      channelType,
      attributes?.toList(),
      dateCreated,
      dateUpdated,
      identity,
      lastReadMessageIndex,
      lastReadTimestamp,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct UserData {
  var identity: String? = nil
  var attributes: AttributesData? = nil
  var friendlyName: String? = nil
  var isNotifiable: Bool? = nil
  var isOnline: Bool? = nil
  var isSubscribed: Bool? = nil

  static func fromList(_ list: [Any?]) -> UserData? {
    let identity: String? = nilOrValue(list[0])
    var attributes: AttributesData? = nil
    if let attributesList: [Any?] = nilOrValue(list[1]) {
      attributes = AttributesData.fromList(attributesList)
    }
    let friendlyName: String? = nilOrValue(list[2])
    let isNotifiable: Bool? = nilOrValue(list[3])
    let isOnline: Bool? = nilOrValue(list[4])
    let isSubscribed: Bool? = nilOrValue(list[5])

    return UserData(
      identity: identity,
      attributes: attributes,
      friendlyName: friendlyName,
      isNotifiable: isNotifiable,
      isOnline: isOnline,
      isSubscribed: isSubscribed
    )
  }
  func toList() -> [Any?] {
    return [
      identity,
      attributes?.toList(),
      friendlyName,
      isNotifiable,
      isOnline,
      isSubscribed,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct MessageCount {
  var count: Int64? = nil

  static func fromList(_ list: [Any?]) -> MessageCount? {
    let count: Int64? = isNullish(list[0]) ? nil : (list[0] is Int64? ? list[0] as! Int64? : Int64(list[0] as! Int32))

    return MessageCount(
      count: count
    )
  }
  func toList() -> [Any?] {
    return [
      count,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct ConversationUpdatedData {
  var conversation: ConversationData? = nil
  var reason: String? = nil

  static func fromList(_ list: [Any?]) -> ConversationUpdatedData? {
    var conversation: ConversationData? = nil
    if let conversationList: [Any?] = nilOrValue(list[0]) {
      conversation = ConversationData.fromList(conversationList)
    }
    let reason: String? = nilOrValue(list[1])

    return ConversationUpdatedData(
      conversation: conversation,
      reason: reason
    )
  }
  func toList() -> [Any?] {
    return [
      conversation?.toList(),
      reason,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct ErrorInfoData {
  var code: Int64? = nil
  var message: String? = nil
  var status: Int64? = nil

  static func fromList(_ list: [Any?]) -> ErrorInfoData? {
    let code: Int64? = isNullish(list[0]) ? nil : (list[0] is Int64? ? list[0] as! Int64? : Int64(list[0] as! Int32))
    let message: String? = nilOrValue(list[1])
    let status: Int64? = isNullish(list[2]) ? nil : (list[2] is Int64? ? list[2] as! Int64? : Int64(list[2] as! Int32))

    return ErrorInfoData(
      code: code,
      message: message,
      status: status
    )
  }
  func toList() -> [Any?] {
    return [
      code,
      message,
      status,
    ]
  }
}

private class PluginApiCodecReader: FlutterStandardReader {
  override func readValue(ofType type: UInt8) -> Any? {
    switch type {
      case 128:
        return ConversationClientData.fromList(self.readValue() as! [Any?])
      case 129:
        return PropertiesData.fromList(self.readValue() as! [Any?])
      default:
        return super.readValue(ofType: type)
    }
  }
}

private class PluginApiCodecWriter: FlutterStandardWriter {
  override func writeValue(_ value: Any) {
    if let value = value as? ConversationClientData {
      super.writeByte(128)
      super.writeValue(value.toList())
    } else if let value = value as? PropertiesData {
      super.writeByte(129)
      super.writeValue(value.toList())
    } else {
      super.writeValue(value)
    }
  }
}

private class PluginApiCodecReaderWriter: FlutterStandardReaderWriter {
  override func reader(with data: Data) -> FlutterStandardReader {
    return PluginApiCodecReader(data: data)
  }

  override func writer(with data: NSMutableData) -> FlutterStandardWriter {
    return PluginApiCodecWriter(data: data)
  }
}

class PluginApiCodec: FlutterStandardMessageCodec {
  static let shared = PluginApiCodec(readerWriter: PluginApiCodecReaderWriter())
}

/// Generated protocol from Pigeon that represents a handler of messages from Flutter.
protocol PluginApi {
  func debug(enableNative: Bool, enableSdk: Bool) throws
  func create(jwtToken: String, properties: PropertiesData, completion: @escaping (Result<ConversationClientData, Error>) -> Void)
}

/// Generated setup class from Pigeon to handle messages through the `binaryMessenger`.
class PluginApiSetup {
  /// The codec used by PluginApi.
  static var codec: FlutterStandardMessageCodec { PluginApiCodec.shared }
  /// Sets up an instance of `PluginApi` to handle messages through the `binaryMessenger`.
  static func setUp(binaryMessenger: FlutterBinaryMessenger, api: PluginApi?) {
    let debugChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.PluginApi.debug", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      debugChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let enableNativeArg = args[0] as! Bool
        let enableSdkArg = args[1] as! Bool
        do {
          try api.debug(enableNative: enableNativeArg, enableSdk: enableSdkArg)
          reply(wrapResult(nil))
        } catch {
          reply(wrapError(error))
        }
      }
    } else {
      debugChannel.setMessageHandler(nil)
    }
    let createChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.PluginApi.create", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      createChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let jwtTokenArg = args[0] as! String
        let propertiesArg = args[1] as! PropertiesData
        api.create(jwtToken: jwtTokenArg, properties: propertiesArg) { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      createChannel.setMessageHandler(nil)
    }
  }
}
private class ConversationClientApiCodecReader: FlutterStandardReader {
  override func readValue(ofType type: UInt8) -> Any? {
    switch type {
      case 128:
        return AttributesData.fromList(self.readValue() as! [Any?])
      case 129:
        return ConversationData.fromList(self.readValue() as! [Any?])
      case 130:
        return TokenData.fromList(self.readValue() as! [Any?])
      case 131:
        return UserData.fromList(self.readValue() as! [Any?])
      default:
        return super.readValue(ofType: type)
    }
  }
}

private class ConversationClientApiCodecWriter: FlutterStandardWriter {
  override func writeValue(_ value: Any) {
    if let value = value as? AttributesData {
      super.writeByte(128)
      super.writeValue(value.toList())
    } else if let value = value as? ConversationData {
      super.writeByte(129)
      super.writeValue(value.toList())
    } else if let value = value as? TokenData {
      super.writeByte(130)
      super.writeValue(value.toList())
    } else if let value = value as? UserData {
      super.writeByte(131)
      super.writeValue(value.toList())
    } else {
      super.writeValue(value)
    }
  }
}

private class ConversationClientApiCodecReaderWriter: FlutterStandardReaderWriter {
  override func reader(with data: Data) -> FlutterStandardReader {
    return ConversationClientApiCodecReader(data: data)
  }

  override func writer(with data: NSMutableData) -> FlutterStandardWriter {
    return ConversationClientApiCodecWriter(data: data)
  }
}

class ConversationClientApiCodec: FlutterStandardMessageCodec {
  static let shared = ConversationClientApiCodec(readerWriter: ConversationClientApiCodecReaderWriter())
}

/// Generated protocol from Pigeon that represents a handler of messages from Flutter.
protocol ConversationClientApi {
  func updateToken(token: String, completion: @escaping (Result<Void, Error>) -> Void)
  func shutdown() throws
  func createConversation(friendlyName: String, completion: @escaping (Result<ConversationData, Error>) -> Void)
  func getMyConversations(completion: @escaping (Result<[ConversationData], Error>) -> Void)
  func getConversation(conversationSidOrUniqueName: String, completion: @escaping (Result<ConversationData, Error>) -> Void)
  func getMyUser(completion: @escaping (Result<UserData, Error>) -> Void)
  func registerForNotification(tokenData: TokenData, completion: @escaping (Result<Void, Error>) -> Void)
  func unregisterForNotification(tokenData: TokenData, completion: @escaping (Result<Void, Error>) -> Void)
}

/// Generated setup class from Pigeon to handle messages through the `binaryMessenger`.
class ConversationClientApiSetup {
  /// The codec used by ConversationClientApi.
  static var codec: FlutterStandardMessageCodec { ConversationClientApiCodec.shared }
  /// Sets up an instance of `ConversationClientApi` to handle messages through the `binaryMessenger`.
  static func setUp(binaryMessenger: FlutterBinaryMessenger, api: ConversationClientApi?) {
    let updateTokenChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationClientApi.updateToken", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      updateTokenChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let tokenArg = args[0] as! String
        api.updateToken(token: tokenArg) { result in
          switch result {
            case .success:
              reply(wrapResult(nil))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      updateTokenChannel.setMessageHandler(nil)
    }
    let shutdownChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationClientApi.shutdown", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      shutdownChannel.setMessageHandler { _, reply in
        do {
          try api.shutdown()
          reply(wrapResult(nil))
        } catch {
          reply(wrapError(error))
        }
      }
    } else {
      shutdownChannel.setMessageHandler(nil)
    }
    let createConversationChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationClientApi.createConversation", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      createConversationChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let friendlyNameArg = args[0] as! String
        api.createConversation(friendlyName: friendlyNameArg) { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      createConversationChannel.setMessageHandler(nil)
    }
    let getMyConversationsChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationClientApi.getMyConversations", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      getMyConversationsChannel.setMessageHandler { _, reply in
        api.getMyConversations() { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      getMyConversationsChannel.setMessageHandler(nil)
    }
    let getConversationChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationClientApi.getConversation", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      getConversationChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidOrUniqueNameArg = args[0] as! String
        api.getConversation(conversationSidOrUniqueName: conversationSidOrUniqueNameArg) { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      getConversationChannel.setMessageHandler(nil)
    }
    let getMyUserChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationClientApi.getMyUser", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      getMyUserChannel.setMessageHandler { _, reply in
        api.getMyUser() { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      getMyUserChannel.setMessageHandler(nil)
    }
    let registerForNotificationChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationClientApi.registerForNotification", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      registerForNotificationChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let tokenDataArg = args[0] as! TokenData
        api.registerForNotification(tokenData: tokenDataArg) { result in
          switch result {
            case .success:
              reply(wrapResult(nil))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      registerForNotificationChannel.setMessageHandler(nil)
    }
    let unregisterForNotificationChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationClientApi.unregisterForNotification", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      unregisterForNotificationChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let tokenDataArg = args[0] as! TokenData
        api.unregisterForNotification(tokenData: tokenDataArg) { result in
          switch result {
            case .success:
              reply(wrapResult(nil))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      unregisterForNotificationChannel.setMessageHandler(nil)
    }
  }
}
private class ConversationApiCodecReader: FlutterStandardReader {
  override func readValue(ofType type: UInt8) -> Any? {
    switch type {
      case 128:
        return AttributesData.fromList(self.readValue() as! [Any?])
      case 129:
        return MediaData.fromList(self.readValue() as! [Any?])
      case 130:
        return MessageCount.fromList(self.readValue() as! [Any?])
      case 131:
        return MessageData.fromList(self.readValue() as! [Any?])
      case 132:
        return MessageOptionsData.fromList(self.readValue() as! [Any?])
      case 133:
        return ParticipantData.fromList(self.readValue() as! [Any?])
      default:
        return super.readValue(ofType: type)
    }
  }
}

private class ConversationApiCodecWriter: FlutterStandardWriter {
  override func writeValue(_ value: Any) {
    if let value = value as? AttributesData {
      super.writeByte(128)
      super.writeValue(value.toList())
    } else if let value = value as? MediaData {
      super.writeByte(129)
      super.writeValue(value.toList())
    } else if let value = value as? MessageCount {
      super.writeByte(130)
      super.writeValue(value.toList())
    } else if let value = value as? MessageData {
      super.writeByte(131)
      super.writeValue(value.toList())
    } else if let value = value as? MessageOptionsData {
      super.writeByte(132)
      super.writeValue(value.toList())
    } else if let value = value as? ParticipantData {
      super.writeByte(133)
      super.writeValue(value.toList())
    } else {
      super.writeValue(value)
    }
  }
}

private class ConversationApiCodecReaderWriter: FlutterStandardReaderWriter {
  override func reader(with data: Data) -> FlutterStandardReader {
    return ConversationApiCodecReader(data: data)
  }

  override func writer(with data: NSMutableData) -> FlutterStandardWriter {
    return ConversationApiCodecWriter(data: data)
  }
}

class ConversationApiCodec: FlutterStandardMessageCodec {
  static let shared = ConversationApiCodec(readerWriter: ConversationApiCodecReaderWriter())
}

/// Generated protocol from Pigeon that represents a handler of messages from Flutter.
protocol ConversationApi {
  func join(conversationSid: String, completion: @escaping (Result<Void, Error>) -> Void)
  func leave(conversationSid: String, completion: @escaping (Result<Void, Error>) -> Void)
  func destroy(conversationSid: String, completion: @escaping (Result<Void, Error>) -> Void)
  func typing(conversationSid: String, completion: @escaping (Result<Void, Error>) -> Void)
  func sendMessage(conversationSid: String, options: MessageOptionsData, completion: @escaping (Result<MessageData, Error>) -> Void)
  func addParticipantByIdentity(conversationSid: String, identity: String, completion: @escaping (Result<Bool, Error>) -> Void)
  func removeParticipant(conversationSid: String, participantSid: String, completion: @escaping (Result<Bool, Error>) -> Void)
  func removeParticipantByIdentity(conversationSid: String, identity: String, completion: @escaping (Result<Bool, Error>) -> Void)
  func getParticipantByIdentity(conversationSid: String, identity: String, completion: @escaping (Result<ParticipantData, Error>) -> Void)
  func getParticipantBySid(conversationSid: String, participantSid: String, completion: @escaping (Result<ParticipantData, Error>) -> Void)
  func getParticipantsList(conversationSid: String, completion: @escaping (Result<[ParticipantData], Error>) -> Void)
  func getMessagesCount(conversationSid: String, completion: @escaping (Result<MessageCount, Error>) -> Void)
  func getUnreadMessagesCount(conversationSid: String, completion: @escaping (Result<Int64, Error>) -> Void)
  func advanceLastReadMessageIndex(conversationSid: String, lastReadMessageIndex: Int64, completion: @escaping (Result<MessageCount, Error>) -> Void)
  func setLastReadMessageIndex(conversationSid: String, lastReadMessageIndex: Int64, completion: @escaping (Result<MessageCount, Error>) -> Void)
  func setAllMessagesRead(conversationSid: String, completion: @escaping (Result<MessageCount, Error>) -> Void)
  func setAllMessagesUnread(conversationSid: String, completion: @escaping (Result<MessageCount, Error>) -> Void)
  func getParticipantsCount(conversationSid: String, completion: @escaping (Result<Int64, Error>) -> Void)
  func getMessagesAfter(conversationSid: String, index: Int64, count: Int64, completion: @escaping (Result<[MessageData], Error>) -> Void)
  func getMessagesBefore(conversationSid: String, index: Int64, count: Int64, completion: @escaping (Result<[MessageData], Error>) -> Void)
  func getMessageByIndex(conversationSid: String, messageIndex: Int64, completion: @escaping (Result<MessageData, Error>) -> Void)
  func getLastMessages(conversationSid: String, count: Int64, completion: @escaping (Result<[MessageData], Error>) -> Void)
  func removeMessage(conversationSid: String, messageIndex: Int64, completion: @escaping (Result<Bool, Error>) -> Void)
  func setAttributes(conversationSid: String, attributes: AttributesData, completion: @escaping (Result<Void, Error>) -> Void)
  func setFriendlyName(conversationSid: String, friendlyName: String, completion: @escaping (Result<Void, Error>) -> Void)
  func setNotificationLevel(conversationSid: String, notificationLevel: String, completion: @escaping (Result<Void, Error>) -> Void)
  func setUniqueName(conversationSid: String, uniqueName: String, completion: @escaping (Result<Void, Error>) -> Void)
}

/// Generated setup class from Pigeon to handle messages through the `binaryMessenger`.
class ConversationApiSetup {
  /// The codec used by ConversationApi.
  static var codec: FlutterStandardMessageCodec { ConversationApiCodec.shared }
  /// Sets up an instance of `ConversationApi` to handle messages through the `binaryMessenger`.
  static func setUp(binaryMessenger: FlutterBinaryMessenger, api: ConversationApi?) {
    let joinChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.join", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      joinChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        api.join(conversationSid: conversationSidArg) { result in
          switch result {
            case .success:
              reply(wrapResult(nil))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      joinChannel.setMessageHandler(nil)
    }
    let leaveChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.leave", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      leaveChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        api.leave(conversationSid: conversationSidArg) { result in
          switch result {
            case .success:
              reply(wrapResult(nil))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      leaveChannel.setMessageHandler(nil)
    }
    let destroyChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.destroy", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      destroyChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        api.destroy(conversationSid: conversationSidArg) { result in
          switch result {
            case .success:
              reply(wrapResult(nil))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      destroyChannel.setMessageHandler(nil)
    }
    let typingChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.typing", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      typingChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        api.typing(conversationSid: conversationSidArg) { result in
          switch result {
            case .success:
              reply(wrapResult(nil))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      typingChannel.setMessageHandler(nil)
    }
    let sendMessageChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.sendMessage", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      sendMessageChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        let optionsArg = args[1] as! MessageOptionsData
        api.sendMessage(conversationSid: conversationSidArg, options: optionsArg) { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      sendMessageChannel.setMessageHandler(nil)
    }
    let addParticipantByIdentityChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.addParticipantByIdentity", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      addParticipantByIdentityChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        let identityArg = args[1] as! String
        api.addParticipantByIdentity(conversationSid: conversationSidArg, identity: identityArg) { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      addParticipantByIdentityChannel.setMessageHandler(nil)
    }
    let removeParticipantChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.removeParticipant", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      removeParticipantChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        let participantSidArg = args[1] as! String
        api.removeParticipant(conversationSid: conversationSidArg, participantSid: participantSidArg) { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      removeParticipantChannel.setMessageHandler(nil)
    }
    let removeParticipantByIdentityChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.removeParticipantByIdentity", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      removeParticipantByIdentityChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        let identityArg = args[1] as! String
        api.removeParticipantByIdentity(conversationSid: conversationSidArg, identity: identityArg) { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      removeParticipantByIdentityChannel.setMessageHandler(nil)
    }
    let getParticipantByIdentityChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.getParticipantByIdentity", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      getParticipantByIdentityChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        let identityArg = args[1] as! String
        api.getParticipantByIdentity(conversationSid: conversationSidArg, identity: identityArg) { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      getParticipantByIdentityChannel.setMessageHandler(nil)
    }
    let getParticipantBySidChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.getParticipantBySid", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      getParticipantBySidChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        let participantSidArg = args[1] as! String
        api.getParticipantBySid(conversationSid: conversationSidArg, participantSid: participantSidArg) { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      getParticipantBySidChannel.setMessageHandler(nil)
    }
    let getParticipantsListChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.getParticipantsList", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      getParticipantsListChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        api.getParticipantsList(conversationSid: conversationSidArg) { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      getParticipantsListChannel.setMessageHandler(nil)
    }
    let getMessagesCountChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.getMessagesCount", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      getMessagesCountChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        api.getMessagesCount(conversationSid: conversationSidArg) { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      getMessagesCountChannel.setMessageHandler(nil)
    }
    let getUnreadMessagesCountChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.getUnreadMessagesCount", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      getUnreadMessagesCountChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        api.getUnreadMessagesCount(conversationSid: conversationSidArg) { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      getUnreadMessagesCountChannel.setMessageHandler(nil)
    }
    let advanceLastReadMessageIndexChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.advanceLastReadMessageIndex", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      advanceLastReadMessageIndexChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        let lastReadMessageIndexArg = args[1] is Int64 ? args[1] as! Int64 : Int64(args[1] as! Int32)
        api.advanceLastReadMessageIndex(conversationSid: conversationSidArg, lastReadMessageIndex: lastReadMessageIndexArg) { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      advanceLastReadMessageIndexChannel.setMessageHandler(nil)
    }
    let setLastReadMessageIndexChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.setLastReadMessageIndex", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      setLastReadMessageIndexChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        let lastReadMessageIndexArg = args[1] is Int64 ? args[1] as! Int64 : Int64(args[1] as! Int32)
        api.setLastReadMessageIndex(conversationSid: conversationSidArg, lastReadMessageIndex: lastReadMessageIndexArg) { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      setLastReadMessageIndexChannel.setMessageHandler(nil)
    }
    let setAllMessagesReadChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.setAllMessagesRead", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      setAllMessagesReadChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        api.setAllMessagesRead(conversationSid: conversationSidArg) { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      setAllMessagesReadChannel.setMessageHandler(nil)
    }
    let setAllMessagesUnreadChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.setAllMessagesUnread", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      setAllMessagesUnreadChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        api.setAllMessagesUnread(conversationSid: conversationSidArg) { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      setAllMessagesUnreadChannel.setMessageHandler(nil)
    }
    let getParticipantsCountChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.getParticipantsCount", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      getParticipantsCountChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        api.getParticipantsCount(conversationSid: conversationSidArg) { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      getParticipantsCountChannel.setMessageHandler(nil)
    }
    let getMessagesAfterChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.getMessagesAfter", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      getMessagesAfterChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        let indexArg = args[1] is Int64 ? args[1] as! Int64 : Int64(args[1] as! Int32)
        let countArg = args[2] is Int64 ? args[2] as! Int64 : Int64(args[2] as! Int32)
        api.getMessagesAfter(conversationSid: conversationSidArg, index: indexArg, count: countArg) { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      getMessagesAfterChannel.setMessageHandler(nil)
    }
    let getMessagesBeforeChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.getMessagesBefore", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      getMessagesBeforeChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        let indexArg = args[1] is Int64 ? args[1] as! Int64 : Int64(args[1] as! Int32)
        let countArg = args[2] is Int64 ? args[2] as! Int64 : Int64(args[2] as! Int32)
        api.getMessagesBefore(conversationSid: conversationSidArg, index: indexArg, count: countArg) { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      getMessagesBeforeChannel.setMessageHandler(nil)
    }
    let getMessageByIndexChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.getMessageByIndex", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      getMessageByIndexChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        let messageIndexArg = args[1] is Int64 ? args[1] as! Int64 : Int64(args[1] as! Int32)
        api.getMessageByIndex(conversationSid: conversationSidArg, messageIndex: messageIndexArg) { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      getMessageByIndexChannel.setMessageHandler(nil)
    }
    let getLastMessagesChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.getLastMessages", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      getLastMessagesChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        let countArg = args[1] is Int64 ? args[1] as! Int64 : Int64(args[1] as! Int32)
        api.getLastMessages(conversationSid: conversationSidArg, count: countArg) { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      getLastMessagesChannel.setMessageHandler(nil)
    }
    let removeMessageChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.removeMessage", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      removeMessageChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        let messageIndexArg = args[1] is Int64 ? args[1] as! Int64 : Int64(args[1] as! Int32)
        api.removeMessage(conversationSid: conversationSidArg, messageIndex: messageIndexArg) { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      removeMessageChannel.setMessageHandler(nil)
    }
    let setAttributesChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.setAttributes", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      setAttributesChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        let attributesArg = args[1] as! AttributesData
        api.setAttributes(conversationSid: conversationSidArg, attributes: attributesArg) { result in
          switch result {
            case .success:
              reply(wrapResult(nil))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      setAttributesChannel.setMessageHandler(nil)
    }
    let setFriendlyNameChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.setFriendlyName", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      setFriendlyNameChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        let friendlyNameArg = args[1] as! String
        api.setFriendlyName(conversationSid: conversationSidArg, friendlyName: friendlyNameArg) { result in
          switch result {
            case .success:
              reply(wrapResult(nil))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      setFriendlyNameChannel.setMessageHandler(nil)
    }
    let setNotificationLevelChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.setNotificationLevel", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      setNotificationLevelChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        let notificationLevelArg = args[1] as! String
        api.setNotificationLevel(conversationSid: conversationSidArg, notificationLevel: notificationLevelArg) { result in
          switch result {
            case .success:
              reply(wrapResult(nil))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      setNotificationLevelChannel.setMessageHandler(nil)
    }
    let setUniqueNameChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ConversationApi.setUniqueName", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      setUniqueNameChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        let uniqueNameArg = args[1] as! String
        api.setUniqueName(conversationSid: conversationSidArg, uniqueName: uniqueNameArg) { result in
          switch result {
            case .success:
              reply(wrapResult(nil))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      setUniqueNameChannel.setMessageHandler(nil)
    }
  }
}
private class ParticipantApiCodecReader: FlutterStandardReader {
  override func readValue(ofType type: UInt8) -> Any? {
    switch type {
      case 128:
        return AttributesData.fromList(self.readValue() as! [Any?])
      case 129:
        return UserData.fromList(self.readValue() as! [Any?])
      default:
        return super.readValue(ofType: type)
    }
  }
}

private class ParticipantApiCodecWriter: FlutterStandardWriter {
  override func writeValue(_ value: Any) {
    if let value = value as? AttributesData {
      super.writeByte(128)
      super.writeValue(value.toList())
    } else if let value = value as? UserData {
      super.writeByte(129)
      super.writeValue(value.toList())
    } else {
      super.writeValue(value)
    }
  }
}

private class ParticipantApiCodecReaderWriter: FlutterStandardReaderWriter {
  override func reader(with data: Data) -> FlutterStandardReader {
    return ParticipantApiCodecReader(data: data)
  }

  override func writer(with data: NSMutableData) -> FlutterStandardWriter {
    return ParticipantApiCodecWriter(data: data)
  }
}

class ParticipantApiCodec: FlutterStandardMessageCodec {
  static let shared = ParticipantApiCodec(readerWriter: ParticipantApiCodecReaderWriter())
}

/// Generated protocol from Pigeon that represents a handler of messages from Flutter.
protocol ParticipantApi {
  func getUser(conversationSid: String, participantSid: String, completion: @escaping (Result<UserData, Error>) -> Void)
  func setAttributes(conversationSid: String, participantSid: String, attributes: AttributesData, completion: @escaping (Result<Void, Error>) -> Void)
  func remove(conversationSid: String, participantSid: String, completion: @escaping (Result<Void, Error>) -> Void)
}

/// Generated setup class from Pigeon to handle messages through the `binaryMessenger`.
class ParticipantApiSetup {
  /// The codec used by ParticipantApi.
  static var codec: FlutterStandardMessageCodec { ParticipantApiCodec.shared }
  /// Sets up an instance of `ParticipantApi` to handle messages through the `binaryMessenger`.
  static func setUp(binaryMessenger: FlutterBinaryMessenger, api: ParticipantApi?) {
    let getUserChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ParticipantApi.getUser", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      getUserChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        let participantSidArg = args[1] as! String
        api.getUser(conversationSid: conversationSidArg, participantSid: participantSidArg) { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      getUserChannel.setMessageHandler(nil)
    }
    let setAttributesChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ParticipantApi.setAttributes", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      setAttributesChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        let participantSidArg = args[1] as! String
        let attributesArg = args[2] as! AttributesData
        api.setAttributes(conversationSid: conversationSidArg, participantSid: participantSidArg, attributes: attributesArg) { result in
          switch result {
            case .success:
              reply(wrapResult(nil))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      setAttributesChannel.setMessageHandler(nil)
    }
    let removeChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.ParticipantApi.remove", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      removeChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        let participantSidArg = args[1] as! String
        api.remove(conversationSid: conversationSidArg, participantSid: participantSidArg) { result in
          switch result {
            case .success:
              reply(wrapResult(nil))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      removeChannel.setMessageHandler(nil)
    }
  }
}
private class MessageApiCodecReader: FlutterStandardReader {
  override func readValue(ofType type: UInt8) -> Any? {
    switch type {
      case 128:
        return AttributesData.fromList(self.readValue() as! [Any?])
      case 129:
        return ParticipantData.fromList(self.readValue() as! [Any?])
      default:
        return super.readValue(ofType: type)
    }
  }
}

private class MessageApiCodecWriter: FlutterStandardWriter {
  override func writeValue(_ value: Any) {
    if let value = value as? AttributesData {
      super.writeByte(128)
      super.writeValue(value.toList())
    } else if let value = value as? ParticipantData {
      super.writeByte(129)
      super.writeValue(value.toList())
    } else {
      super.writeValue(value)
    }
  }
}

private class MessageApiCodecReaderWriter: FlutterStandardReaderWriter {
  override func reader(with data: Data) -> FlutterStandardReader {
    return MessageApiCodecReader(data: data)
  }

  override func writer(with data: NSMutableData) -> FlutterStandardWriter {
    return MessageApiCodecWriter(data: data)
  }
}

class MessageApiCodec: FlutterStandardMessageCodec {
  static let shared = MessageApiCodec(readerWriter: MessageApiCodecReaderWriter())
}

/// Generated protocol from Pigeon that represents a handler of messages from Flutter.
protocol MessageApi {
  func getTemporaryContentUrlsForMedia(conversationSid: String, messageIndex: Int64, completion: @escaping (Result<[String: String], Error>) -> Void)
  func getParticipant(conversationSid: String, messageIndex: Int64, completion: @escaping (Result<ParticipantData, Error>) -> Void)
  func setAttributes(conversationSid: String, messageIndex: Int64, attributes: AttributesData, completion: @escaping (Result<Void, Error>) -> Void)
  func updateMessageBody(conversationSid: String, messageIndex: Int64, messageBody: String, completion: @escaping (Result<Void, Error>) -> Void)
}

/// Generated setup class from Pigeon to handle messages through the `binaryMessenger`.
class MessageApiSetup {
  /// The codec used by MessageApi.
  static var codec: FlutterStandardMessageCodec { MessageApiCodec.shared }
  /// Sets up an instance of `MessageApi` to handle messages through the `binaryMessenger`.
  static func setUp(binaryMessenger: FlutterBinaryMessenger, api: MessageApi?) {
    let getTemporaryContentUrlsForMediaChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.MessageApi.getTemporaryContentUrlsForMedia", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      getTemporaryContentUrlsForMediaChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        let messageIndexArg = args[1] is Int64 ? args[1] as! Int64 : Int64(args[1] as! Int32)
        api.getTemporaryContentUrlsForMedia(conversationSid: conversationSidArg, messageIndex: messageIndexArg) { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      getTemporaryContentUrlsForMediaChannel.setMessageHandler(nil)
    }
    let getParticipantChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.MessageApi.getParticipant", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      getParticipantChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        let messageIndexArg = args[1] is Int64 ? args[1] as! Int64 : Int64(args[1] as! Int32)
        api.getParticipant(conversationSid: conversationSidArg, messageIndex: messageIndexArg) { result in
          switch result {
            case .success(let res):
              reply(wrapResult(res))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      getParticipantChannel.setMessageHandler(nil)
    }
    let setAttributesChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.MessageApi.setAttributes", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      setAttributesChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        let messageIndexArg = args[1] is Int64 ? args[1] as! Int64 : Int64(args[1] as! Int32)
        let attributesArg = args[2] as! AttributesData
        api.setAttributes(conversationSid: conversationSidArg, messageIndex: messageIndexArg, attributes: attributesArg) { result in
          switch result {
            case .success:
              reply(wrapResult(nil))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      setAttributesChannel.setMessageHandler(nil)
    }
    let updateMessageBodyChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.MessageApi.updateMessageBody", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      updateMessageBodyChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let conversationSidArg = args[0] as! String
        let messageIndexArg = args[1] is Int64 ? args[1] as! Int64 : Int64(args[1] as! Int32)
        let messageBodyArg = args[2] as! String
        api.updateMessageBody(conversationSid: conversationSidArg, messageIndex: messageIndexArg, messageBody: messageBodyArg) { result in
          switch result {
            case .success:
              reply(wrapResult(nil))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      updateMessageBodyChannel.setMessageHandler(nil)
    }
  }
}
private class UserApiCodecReader: FlutterStandardReader {
  override func readValue(ofType type: UInt8) -> Any? {
    switch type {
      case 128:
        return AttributesData.fromList(self.readValue() as! [Any?])
      default:
        return super.readValue(ofType: type)
    }
  }
}

private class UserApiCodecWriter: FlutterStandardWriter {
  override func writeValue(_ value: Any) {
    if let value = value as? AttributesData {
      super.writeByte(128)
      super.writeValue(value.toList())
    } else {
      super.writeValue(value)
    }
  }
}

private class UserApiCodecReaderWriter: FlutterStandardReaderWriter {
  override func reader(with data: Data) -> FlutterStandardReader {
    return UserApiCodecReader(data: data)
  }

  override func writer(with data: NSMutableData) -> FlutterStandardWriter {
    return UserApiCodecWriter(data: data)
  }
}

class UserApiCodec: FlutterStandardMessageCodec {
  static let shared = UserApiCodec(readerWriter: UserApiCodecReaderWriter())
}

/// Generated protocol from Pigeon that represents a handler of messages from Flutter.
protocol UserApi {
  func setFriendlyName(identity: String, friendlyName: String, completion: @escaping (Result<Void, Error>) -> Void)
  func setAttributes(identity: String, attributes: AttributesData, completion: @escaping (Result<Void, Error>) -> Void)
}

/// Generated setup class from Pigeon to handle messages through the `binaryMessenger`.
class UserApiSetup {
  /// The codec used by UserApi.
  static var codec: FlutterStandardMessageCodec { UserApiCodec.shared }
  /// Sets up an instance of `UserApi` to handle messages through the `binaryMessenger`.
  static func setUp(binaryMessenger: FlutterBinaryMessenger, api: UserApi?) {
    let setFriendlyNameChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.UserApi.setFriendlyName", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      setFriendlyNameChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let identityArg = args[0] as! String
        let friendlyNameArg = args[1] as! String
        api.setFriendlyName(identity: identityArg, friendlyName: friendlyNameArg) { result in
          switch result {
            case .success:
              reply(wrapResult(nil))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      setFriendlyNameChannel.setMessageHandler(nil)
    }
    let setAttributesChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.UserApi.setAttributes", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      setAttributesChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let identityArg = args[0] as! String
        let attributesArg = args[1] as! AttributesData
        api.setAttributes(identity: identityArg, attributes: attributesArg) { result in
          switch result {
            case .success:
              reply(wrapResult(nil))
            case .failure(let error):
              reply(wrapError(error))
          }
        }
      }
    } else {
      setAttributesChannel.setMessageHandler(nil)
    }
  }
}
private class FlutterConversationClientApiCodecReader: FlutterStandardReader {
  override func readValue(ofType type: UInt8) -> Any? {
    switch type {
      case 128:
        return AttributesData.fromList(self.readValue() as! [Any?])
      case 129:
        return ConversationData.fromList(self.readValue() as! [Any?])
      case 130:
        return ConversationUpdatedData.fromList(self.readValue() as! [Any?])
      case 131:
        return ErrorInfoData.fromList(self.readValue() as! [Any?])
      case 132:
        return MediaData.fromList(self.readValue() as! [Any?])
      case 133:
        return MessageData.fromList(self.readValue() as! [Any?])
      case 134:
        return ParticipantData.fromList(self.readValue() as! [Any?])
      case 135:
        return UserData.fromList(self.readValue() as! [Any?])
      default:
        return super.readValue(ofType: type)
    }
  }
}

private class FlutterConversationClientApiCodecWriter: FlutterStandardWriter {
  override func writeValue(_ value: Any) {
    if let value = value as? AttributesData {
      super.writeByte(128)
      super.writeValue(value.toList())
    } else if let value = value as? ConversationData {
      super.writeByte(129)
      super.writeValue(value.toList())
    } else if let value = value as? ConversationUpdatedData {
      super.writeByte(130)
      super.writeValue(value.toList())
    } else if let value = value as? ErrorInfoData {
      super.writeByte(131)
      super.writeValue(value.toList())
    } else if let value = value as? MediaData {
      super.writeByte(132)
      super.writeValue(value.toList())
    } else if let value = value as? MessageData {
      super.writeByte(133)
      super.writeValue(value.toList())
    } else if let value = value as? ParticipantData {
      super.writeByte(134)
      super.writeValue(value.toList())
    } else if let value = value as? UserData {
      super.writeByte(135)
      super.writeValue(value.toList())
    } else {
      super.writeValue(value)
    }
  }
}

private class FlutterConversationClientApiCodecReaderWriter: FlutterStandardReaderWriter {
  override func reader(with data: Data) -> FlutterStandardReader {
    return FlutterConversationClientApiCodecReader(data: data)
  }

  override func writer(with data: NSMutableData) -> FlutterStandardWriter {
    return FlutterConversationClientApiCodecWriter(data: data)
  }
}

class FlutterConversationClientApiCodec: FlutterStandardMessageCodec {
  static let shared = FlutterConversationClientApiCodec(readerWriter: FlutterConversationClientApiCodecReaderWriter())
}

/// Generated class from Pigeon that represents Flutter messages that can be called from Swift.
class FlutterConversationClientApi {
  private let binaryMessenger: FlutterBinaryMessenger
  init(binaryMessenger: FlutterBinaryMessenger){
    self.binaryMessenger = binaryMessenger
  }
  var codec: FlutterStandardMessageCodec {
    return FlutterConversationClientApiCodec.shared
  }
  func error(errorInfoData errorInfoDataArg: ErrorInfoData, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.error", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([errorInfoDataArg] as [Any?]) { _ in
      completion()
    }
  }
  func conversationAdded(conversationData conversationDataArg: ConversationData, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.conversationAdded", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([conversationDataArg] as [Any?]) { _ in
      completion()
    }
  }
  func conversationUpdated(event eventArg: ConversationUpdatedData, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.conversationUpdated", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([eventArg] as [Any?]) { _ in
      completion()
    }
  }
  func conversationDeleted(conversationData conversationDataArg: ConversationData, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.conversationDeleted", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([conversationDataArg] as [Any?]) { _ in
      completion()
    }
  }
  func clientSynchronization(synchronizationStatus synchronizationStatusArg: String, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.clientSynchronization", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([synchronizationStatusArg] as [Any?]) { _ in
      completion()
    }
  }
  func conversationSynchronizationChange(conversationData conversationDataArg: ConversationData, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.conversationSynchronizationChange", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([conversationDataArg] as [Any?]) { _ in
      completion()
    }
  }
  func connectionStateChange(connectionState connectionStateArg: String, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.connectionStateChange", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([connectionStateArg] as [Any?]) { _ in
      completion()
    }
  }
  func tokenAboutToExpire(completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.tokenAboutToExpire", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage(nil) { _ in
      completion()
    }
  }
  func tokenExpired(completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.tokenExpired", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage(nil) { _ in
      completion()
    }
  }
  func userSubscribed(userData userDataArg: UserData, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.userSubscribed", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([userDataArg] as [Any?]) { _ in
      completion()
    }
  }
  func userUnsubscribed(userData userDataArg: UserData, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.userUnsubscribed", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([userDataArg] as [Any?]) { _ in
      completion()
    }
  }
  func userUpdated(userData userDataArg: UserData, reason reasonArg: String, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.userUpdated", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([userDataArg, reasonArg] as [Any?]) { _ in
      completion()
    }
  }
  func addedToConversationNotification(conversationSid conversationSidArg: String, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.addedToConversationNotification", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([conversationSidArg] as [Any?]) { _ in
      completion()
    }
  }
  func newMessageNotification(conversationSid conversationSidArg: String, messageIndex messageIndexArg: Int64, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.newMessageNotification", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([conversationSidArg, messageIndexArg] as [Any?]) { _ in
      completion()
    }
  }
  func notificationSubscribed(completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.notificationSubscribed", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage(nil) { _ in
      completion()
    }
  }
  func notificationFailed(errorInfoData errorInfoDataArg: ErrorInfoData, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.notificationFailed", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([errorInfoDataArg] as [Any?]) { _ in
      completion()
    }
  }
  func removedFromConversationNotification(conversationSid conversationSidArg: String, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.removedFromConversationNotification", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([conversationSidArg] as [Any?]) { _ in
      completion()
    }
  }
  func registered(completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.registered", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage(nil) { _ in
      completion()
    }
  }
  func registrationFailed(errorInfoData errorInfoDataArg: ErrorInfoData, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.registrationFailed", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([errorInfoDataArg] as [Any?]) { _ in
      completion()
    }
  }
  func deregistered(completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.deregistered", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage(nil) { _ in
      completion()
    }
  }
  func deregistrationFailed(errorInfoData errorInfoDataArg: ErrorInfoData, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.deregistrationFailed", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([errorInfoDataArg] as [Any?]) { _ in
      completion()
    }
  }
  func messageAdded(conversationSid conversationSidArg: String, messageData messageDataArg: MessageData, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.messageAdded", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([conversationSidArg, messageDataArg] as [Any?]) { _ in
      completion()
    }
  }
  func messageUpdated(conversationSid conversationSidArg: String, messageData messageDataArg: MessageData, reason reasonArg: String, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.messageUpdated", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([conversationSidArg, messageDataArg, reasonArg] as [Any?]) { _ in
      completion()
    }
  }
  func messageDeleted(conversationSid conversationSidArg: String, messageData messageDataArg: MessageData, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.messageDeleted", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([conversationSidArg, messageDataArg] as [Any?]) { _ in
      completion()
    }
  }
  func participantAdded(conversationSid conversationSidArg: String, participantData participantDataArg: ParticipantData, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.participantAdded", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([conversationSidArg, participantDataArg] as [Any?]) { _ in
      completion()
    }
  }
  func participantUpdated(conversationSid conversationSidArg: String, participantData participantDataArg: ParticipantData, reason reasonArg: String, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.participantUpdated", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([conversationSidArg, participantDataArg, reasonArg] as [Any?]) { _ in
      completion()
    }
  }
  func participantDeleted(conversationSid conversationSidArg: String, participantData participantDataArg: ParticipantData, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.participantDeleted", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([conversationSidArg, participantDataArg] as [Any?]) { _ in
      completion()
    }
  }
  func typingStarted(conversationSid conversationSidArg: String, conversationData conversationDataArg: ConversationData, participantData participantDataArg: ParticipantData, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.typingStarted", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([conversationSidArg, conversationDataArg, participantDataArg] as [Any?]) { _ in
      completion()
    }
  }
  func typingEnded(conversationSid conversationSidArg: String, conversationData conversationDataArg: ConversationData, participantData participantDataArg: ParticipantData, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.typingEnded", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([conversationSidArg, conversationDataArg, participantDataArg] as [Any?]) { _ in
      completion()
    }
  }
  func synchronizationChanged(conversationSid conversationSidArg: String, conversationData conversationDataArg: ConversationData, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterConversationClientApi.synchronizationChanged", binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([conversationSidArg, conversationDataArg] as [Any?]) { _ in
      completion()
    }
  }
}
/// Generated class from Pigeon that represents Flutter messages that can be called from Swift.
class FlutterLoggingApi {
  private let binaryMessenger: FlutterBinaryMessenger
  init(binaryMessenger: FlutterBinaryMessenger){
    self.binaryMessenger = binaryMessenger
  }
  func logFromHost(msg msgArg: String, completion: @escaping () -> Void) {
    let channel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.twilio_conversations.FlutterLoggingApi.logFromHost", binaryMessenger: binaryMessenger)
    channel.sendMessage([msgArg] as [Any?]) { _ in
      completion()
    }
  }
}
